package de.japhy.tools.configLog4j;

import javax.swing.Icon;
import java.util.TreeSet;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.InputEvent;
import javax.swing.tree.TreePath;

/**
 * @author  <A HREF="mailto:tobias@dezulian.de">Tobias Dezulian</A>
 */
public class CategoryTree extends PropagatingTree implements ActionListener{

  //the node for which a state has been chosen previously in the popup menu.
  CategoryNode popupChosenNode = null;

  private class PTMouseListener extends MouseAdapter{
    public void mousePressed(MouseEvent e) {
         int selRow = tree.getRowForLocation(e.getX(), e.getY());
         TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
         if(selRow != -1) {
          if(e.getClickCount() == 1) {
            if((e.getModifiers() & InputEvent.BUTTON3_MASK)
                == InputEvent.BUTTON3_MASK){
                //the right mouse button was pressed

                JPopupMenu pop = new JPopupMenu();
                JMenuItem menuItem;
                menuItem = new JMenuItem("FATAL");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);
                menuItem = new JMenuItem("ERROR");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);
                menuItem = new JMenuItem("WARN");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);
                menuItem = new JMenuItem("INFO");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);
                menuItem = new JMenuItem("DEBUG");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);
                menuItem = new JMenuItem("NONE");
                menuItem.addActionListener(CategoryTree.this);
                pop.add(menuItem);

                pop.show(CategoryTree.this, e.getX(), e.getY());
                popupChosenNode=(CategoryNode)selPath.getLastPathComponent();
            }

              //TreeFrame.this.setCursor(Cursor.WAIT_CURSOR);
              e.getComponent().repaint();
              //TreeFrame.this.setCursor(Cursor.DEFAULT_CURSOR);
              }
              else if(e.getClickCount() == 2) {
                //myDoubleClick(selRow, selPath);
              }
          }
     }
  }
  public CategoryTree(TreeSet inputObjects) {
    super( inputObjects );
    this.addMouseListener(new PTMouseListener());
  }
  public void actionPerformed(ActionEvent e){
      if(e.getActionCommand().equalsIgnoreCase("FATAL")){
        popupChosenNode.setFatal();
      }
      else if(e.getActionCommand().equalsIgnoreCase("ERROR")){
        popupChosenNode.setError();
      }
      else if(e.getActionCommand().equalsIgnoreCase("WARN")){
        popupChosenNode.setWarn();
      }
      else if(e.getActionCommand().equalsIgnoreCase("INFO")){
        popupChosenNode.setInfo();
      }
      else if(e.getActionCommand().equalsIgnoreCase("DEBUG")){
        popupChosenNode.setDebug();
      }
      else if(e.getActionCommand().equalsIgnoreCase("NONE")){
        popupChosenNode.setNone();
      }
      if(!popupChosenNode.isLeaf()){
        popupChosenNode.propagateStateRec();
      }
      CategoryNode dad = (CategoryNode) popupChosenNode.getParent();
      if(!dad.isRoot()){
        dad.checkYourselfRec();
      }
      this.repaint();
  }
  protected PropagatingNode createNode(Object obj){
    return new CategoryNode(obj);
  }
    public TreeSet getDebugCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.DEBUG);
      return resultSet;
    }
    public TreeSet getErrorCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.ERROR);
      return resultSet;
    }
    public TreeSet getFatalCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.FATAL);
      return resultSet;
    }
    public TreeSet getInfoCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.INFO);
      return resultSet;
    }
    public TreeSet getNoneCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.NONE);
      return resultSet;
    }
    public TreeSet getWarnCategories(){
      TreeSet resultSet=new TreeSet();
      recursiveAddToResultSet((PropagatingNode) this.getModel().getRoot(), resultSet, ConfigLog4jConfiguration.WARN);
      return resultSet;
    }
    private void recursiveAddToResultSet(PropagatingNode node, TreeSet ts, Integer stateItem){
      //this method only adds class categories !!!
      node = (CategoryNode) node;
      if(node.isLeaf()){
        if(node.getState().contains(stateItem)){
          ts.add(node.getUserObject().toString());
        }
      }
      else{
        //inner node
       int childNum=node.getChildCount();
        CategoryNode childNode;
        for(int i=0; i<childNum; i++){
          childNode=(CategoryNode) node.getChildAt(i);
          recursiveAddToResultSet(childNode, ts, stateItem);
        }
      }
    }
}
