/**
 * This Software is freeware.
 * Feel free to use/modify/distribute.
 */
package de.japhy.tools.configLog4j;

import java.util.Vector;

/**
 * provides commonly used utility methods
 *
 * @author  <A HREF="mailto:tobias@dezulian.de">Tobias Dezulian</A>
 */
public class Helper {
  public static boolean debug = false;

  public Helper() {
  }

  public static void error(String s){
    System.err.println("error: "+s);
    System.err.println("(if line numbers in stack trace don't show, turn off JIT !)");
    try{
      throw new Throwable();
    }catch(Throwable th){
      th.printStackTrace();
    }
    System.exit(-1);
  }
  public static void out(String s){
    System.out.println(s);
  }
  public static void printNodes(PropagatingNode node){
    Vector v = new Vector();
    printNodesRec(node, v);
    for(int i=0; i<v.size(); i++){
      System.err.println(" "+i+":  "+(String) v.elementAt(i));
    }
  }

  private static void printNodesRec(PropagatingNode node, Vector v){
    v.add(node.getUserObject().toString());
    int childNum=node.getChildCount();
    PropagatingNode childNode;
    for(int i=0; i<childNum; i++){
      childNode=(PropagatingNode) node.getChildAt(i);
      printNodesRec(childNode, v);
    }

  }

}