/**
 * This Software is freeware.
 * Feel free to use/modify/distribute.
 */
package de.japhy.tools.configLog4j;

/**
 * This class is about as ugly as they get - sorry for that. <p>
 * Does a bit of String comparison to find out is a fully qualified
 * name denotes a class or a package. <p>
 * First class letter has got to be capitalized of course.
 *
 * @author  <A HREF="mailto:tobias@dezulian.de">Tobias Dezulian</A>
 */
public class StringHelper {

      public static String strippedName(String fullname){
        StringBuffer sb=new StringBuffer();
        if(isClass(fullname)){
          sb.append(fullname.substring(fullname.lastIndexOf('.')+1, fullname.length()));
        }
        else{
          sb.append(fullname.substring(fullname.lastIndexOf('.')+1, fullname.length()));
        }
        return sb.toString();
      }
      public static boolean isClass(String fullname){
        //if(fullname.indexOf('.')==-1)
        //works even if no package name is explicitly given.
        if(Character.isUpperCase(fullname.charAt(fullname.lastIndexOf('.')+1)))
          return true;
        else
          return false;
      }
      public static boolean isClassOfThisOrSubPackage(String possibleClassName, String possiblePackageName){
        if(
            isPackage(possiblePackageName)
            && isClass(possibleClassName)
            && possibleClassName.startsWith(possiblePackageName)
            && (possiblePackageName.length()+1<possibleClassName.length())
            && (possibleClassName.charAt(possiblePackageName.length()+0) == '.')
          ){
          //System.err.println("isClassOfThisOrSubPackage("+fullclassname+", "+fullpackagename+"): true.");
          return true;
        }else{
          //System.err.println("isClassOfThisOrSubPackage("+fullclassname+", "+fullpackagename+"): false.");
          return false;
        }
       }
      public static boolean isPackageOfThisOrSubPackage(String possibleChildPackage, String possibleParentPackage){
        if(
            isPackage(possibleChildPackage)
            && isPackage(possibleParentPackage)
            && possibleChildPackage.startsWith(possibleParentPackage)
            && (possibleParentPackage.length()+1<possibleChildPackage.length())
            && (possibleChildPackage.charAt(possibleParentPackage.length()+0) == '.')
          ){
          //A is sub of B
          //System.err.println("isPackageOfThisOrSubPackage("+possibleChildPackage+", "+possibleParentPackage+"): true.");
          return true;
        }else{
          //System.err.println("isPackageOfThisOrSubPackage("+possibleChildPackage+", "+possibleParentPackage+"): false.");
          return false;
        }
      }
      public static boolean isClassOfPackage(String fullclassname, String fullpackagename){
      String dreck=null;
      boolean jeff;
      try{
        if(
            isClassOfThisOrSubPackage(fullclassname, fullpackagename)
            && (dreck=fullclassname.substring(0, fullclassname.lastIndexOf('.'))).equals(fullpackagename)
          ){
          //System.err.println("isClassOfPackage("+fullclassname+", "+fullpackagename+"): true."+dreck);
          return true;
        }else{
          //System.err.println("isClassOfPackage("+fullclassname+", "+fullpackagename+"): false."+dreck);
          return false;
        }
      }catch(Exception e){
        e.printStackTrace(System.err);
        System.err.println(e.toString()+"fullclassname: "+fullclassname+"   fullpackagename: "+fullpackagename);
      }
      return false; //keep compiler happy
      }
      public static boolean isPackageOfPackage(String possibleChildPackage, String possibleParentPackage){
        if(
            isPackageOfThisOrSubPackage(possibleChildPackage, possibleParentPackage)
            && ( possibleChildPackage.indexOf('.') != -1 )
            && possibleChildPackage.substring(0, possibleChildPackage.lastIndexOf('.')).equals(possibleParentPackage)
          ){
          //A is direkt sub of B
          //System.err.println("isPackageOfPackage("+possibleChildPackage+", "+possibleParentPackage+"): true.");
          return true;
        }else{
          //System.err.println("isPackageOfPackage("+possibleChildPackage+", "+possibleParentPackage+"): false.");
          return false;
        }
      }
      public static boolean isPackage(String fullname){
        return !isClass(fullname);
      }

}